| Method from org.apache.catalina.hostmanager.HostManagerServlet Detail: |
protected void add(HttpServletRequest request,
PrintWriter writer,
String name,
boolean htmlMode) {
String aliases = request.getParameter("aliases");
String appBase = request.getParameter("appBase");
boolean manager = booleanParameter(request, "manager", true, htmlMode);
boolean autoDeploy = booleanParameter(request, "autoDeploy", true, htmlMode);
boolean deployOnStartup = booleanParameter(request, "deployOnStartup", true, htmlMode);
boolean deployXML = booleanParameter(request, "deployXML", true, htmlMode);
boolean unpackWARs = booleanParameter(request, "unpackWARs", true, htmlMode);
boolean xmlNamespaceAware = booleanParameter(request, "xmlNamespaceAware", false, htmlMode);
boolean xmlValidation = booleanParameter(request, "xmlValidation", false, htmlMode);
add(writer, name, aliases, appBase, manager,
autoDeploy,
deployOnStartup,
deployXML,
unpackWARs,
xmlNamespaceAware,
xmlValidation);
}
Add host with all parameter |
protected synchronized void add(PrintWriter writer,
String name,
String aliases,
String appBase,
boolean manager,
boolean autoDeploy,
boolean deployOnStartup,
boolean deployXML,
boolean unpackWARs,
boolean xmlNamespaceAware,
boolean xmlValidation) {
if (debug >= 1) {
log("add: Adding host '" + name + "'");
}
// Validate the requested host name
if ((name == null) || name.length() == 0) {
writer.println(sm.getString("hostManagerServlet.invalidHostName", name));
return;
}
// Check if host already exists
if (engine.findChild(name) != null) {
writer.println
(sm.getString("hostManagerServlet.alreadyHost", name));
return;
}
// Validate and create appBase
File appBaseFile = null;
if (appBase == null || appBase.length() == 0) {
appBase = name;
}
File file = new File(appBase);
if (!file.isAbsolute())
file = new File(System.getProperty("catalina.base"), appBase);
try {
appBaseFile = file.getCanonicalFile();
} catch (IOException e) {
appBaseFile = file;
}
if (!appBaseFile.exists()) {
appBaseFile.mkdirs();
}
// Create base for config files
File configBaseFile = getConfigBase(name);
// Copy manager.xml if requested
if (manager) {
InputStream is = null;
OutputStream os = null;
try {
is = getServletContext().getResourceAsStream("/manager.xml");
os = new FileOutputStream(new File(configBaseFile, "manager.xml"));
byte buffer[] = new byte[512];
int len = buffer.length;
while (true) {
len = is.read(buffer);
if (len == -1)
break;
os.write(buffer, 0, len);
}
} catch (IOException e) {
writer.println
(sm.getString("hostManagerServlet.managerXml"));
return;
} finally {
if (is != null) {
try {
is.close();
} catch (IOException e) {
}
}
if (os != null) {
try {
os.close();
} catch (IOException e) {
}
}
}
}
StandardHost host = new StandardHost();
host.setAppBase(appBase);
host.setName(name);
host.addLifecycleListener(new HostConfig());
// Add host aliases
if ((aliases != null) && !("".equals(aliases))) {
StringTokenizer tok = new StringTokenizer(aliases, ",");
while (tok.hasMoreTokens()) {
host.addAlias(tok.nextToken());
}
}
host.setAutoDeploy(autoDeploy);
host.setDeployOnStartup(deployOnStartup);
host.setDeployXML(deployXML);
host.setUnpackWARs(unpackWARs);
host.setXmlNamespaceAware(xmlNamespaceAware);
host.setXmlValidation(xmlValidation);
// Add new host
try {
engine.addChild(host);
} catch (Exception e) {
writer.println(sm.getString("hostManagerServlet.exception",
e.toString()));
return;
}
host = (StandardHost) engine.findChild(name);
if (host != null) {
writer.println(sm.getString("hostManagerServlet.add", name));
} else {
// Something failed
writer.println(sm.getString("hostManagerServlet.addFailed", name));
}
}
Add a host using the specified parameters. |
protected boolean booleanParameter(HttpServletRequest request,
String parameter,
boolean theDefault,
boolean htmlMode) {
String value = request.getParameter(parameter);
boolean booleanValue = theDefault;
if (value != null) {
if (htmlMode) {
if (value.equals("on")) {
booleanValue = true;
}
} else if (theDefault) {
if (value.equals("false")) {
booleanValue = false;
}
} else if (value.equals("true")) {
booleanValue = true;
}
} else if (htmlMode)
booleanValue = false;
return booleanValue;
}
extract boolean value from checkbox with default |
public void destroy() {
; // No actions necessary
}
|
public void doGet(HttpServletRequest request,
HttpServletResponse response) throws IOException, ServletException {
// Verify that we were not accessed using the invoker servlet
if (request.getAttribute(Globals.INVOKED_ATTR) != null)
throw new UnavailableException
(sm.getString("hostManagerServlet.cannotInvoke"));
// Identify the request parameters that we need
String command = request.getPathInfo();
if (command == null)
command = request.getServletPath();
String name = request.getParameter("name");
// Prepare our output writer to generate the response message
response.setContentType("text/plain; charset=" + Constants.CHARSET);
PrintWriter writer = response.getWriter();
// Process the requested command
if (command == null) {
writer.println(sm.getString("hostManagerServlet.noCommand"));
} else if (command.equals("/add")) {
add(request, writer, name, false);
} else if (command.equals("/remove")) {
remove(writer, name);
} else if (command.equals("/list")) {
list(writer);
} else if (command.equals("/start")) {
start(writer, name);
} else if (command.equals("/stop")) {
stop(writer, name);
} else {
writer.println(sm.getString("hostManagerServlet.unknownCommand",
command));
}
// Finish up the response
writer.flush();
writer.close();
}
Process a GET request for the specified resource. |
protected File getConfigBase(String hostName) {
File configBase =
new File(System.getProperty("catalina.base"), "conf");
if (!configBase.exists()) {
return null;
}
if (engine != null) {
configBase = new File(configBase, engine.getName());
}
if (host != null) {
configBase = new File(configBase, hostName);
}
configBase.mkdirs();
return configBase;
}
|
public Wrapper getWrapper() {
// ----------------------------------------------- ContainerServlet Methods
return (this.wrapper);
}
Return the Wrapper with which we are associated. |
public void init() throws ServletException {
// Ensure that our ContainerServlet properties have been set
if ((wrapper == null) || (context == null))
throw new UnavailableException
(sm.getString("hostManagerServlet.noWrapper"));
// Verify that we were not accessed using the invoker servlet
String servletName = getServletConfig().getServletName();
if (servletName == null)
servletName = "";
if (servletName.startsWith("org.apache.catalina.INVOKER."))
throw new UnavailableException
(sm.getString("hostManagerServlet.cannotInvoke"));
// Set our properties from the initialization parameters
String value = null;
try {
value = getServletConfig().getInitParameter("debug");
debug = Integer.parseInt(value);
} catch (Throwable t) {
;
}
}
|
protected void list(PrintWriter writer) {
if (debug >= 1)
log("list: Listing hosts for engine '"
+ engine.getName() + "'");
writer.println(sm.getString("hostManagerServlet.listed",
engine.getName()));
Container[] hosts = engine.findChildren();
for (int i = 0; i < hosts.length; i++) {
Host host = (Host) hosts[i];
String name = host.getName();
String[] aliases = host.findAliases();
StringBuffer buf = new StringBuffer();
if (aliases.length > 0) {
buf.append(aliases[0]);
for (int j = 1; j < aliases.length; j++) {
buf.append(',").append(aliases[j]);
}
}
writer.println(sm.getString("hostManagerServlet.listitem",
name, buf.toString()));
}
}
Render a list of the currently active Contexts in our virtual host. |
protected synchronized void remove(PrintWriter writer,
String name) {
if (debug >= 1) {
log("remove: Removing host '" + name + "'");
}
// Validate the requested host name
if ((name == null) || name.length() == 0) {
writer.println(sm.getString("hostManagerServlet.invalidHostName", name));
return;
}
// Check if host exists
if (engine.findChild(name) == null) {
writer.println
(sm.getString("hostManagerServlet.noHost", name));
return;
}
// Prevent removing our own host
if (engine.findChild(name) == host) {
writer.println
(sm.getString("hostManagerServlet.cannotRemoveOwnHost", name));
return;
}
// Remove host
// Note that the host will not get physically removed
try {
engine.removeChild(engine.findChild(name));
} catch (Exception e) {
writer.println(sm.getString("hostManagerServlet.exception",
e.toString()));
return;
}
Host host = (StandardHost) engine.findChild(name);
if (host == null) {
writer.println(sm.getString("hostManagerServlet.remove", name));
} else {
// Something failed
writer.println(sm.getString("hostManagerServlet.removeFailed", name));
}
}
Remove the specified host. |
public void setWrapper(Wrapper wrapper) {
this.wrapper = wrapper;
if (wrapper == null) {
context = null;
host = null;
engine = null;
} else {
context = (Context) wrapper.getParent();
host = (Host) context.getParent();
engine = (Engine) host.getParent();
}
// Retrieve the MBean server
mBeanServer = Registry.getRegistry(null, null).getMBeanServer();
}
Set the Wrapper with which we are associated. |
protected void start(PrintWriter writer,
String name) {
if (debug >= 1)
log("start: Starting host with name '" + name + "'");
// Validate the requested host name
if ((name == null) || name.length() == 0) {
writer.println(sm.getString("hostManagerServlet.invalidHostName", name));
return;
}
// Check if host exists
if (engine.findChild(name) == null) {
writer.println
(sm.getString("hostManagerServlet.noHost", name));
return;
}
// Prevent starting our own host
if (engine.findChild(name) == host) {
writer.println
(sm.getString("hostManagerServlet.cannotStartOwnHost", name));
return;
}
// Start host
try {
((Lifecycle) engine.findChild(name)).start();
writer.println
(sm.getString("hostManagerServlet.started", name));
} catch (Throwable t) {
getServletContext().log
(sm.getString("hostManagerServlet.startFailed", name), t);
writer.println
(sm.getString("hostManagerServlet.startFailed", name));
writer.println(sm.getString("hostManagerServlet.exception",
t.toString()));
return;
}
}
Start the host with the specified name. |
protected void stop(PrintWriter writer,
String name) {
if (debug >= 1)
log("stop: Stopping host with name '" + name + "'");
// Validate the requested host name
if ((name == null) || name.length() == 0) {
writer.println(sm.getString("hostManagerServlet.invalidHostName", name));
return;
}
// Check if host exists
if (engine.findChild(name) == null) {
writer.println
(sm.getString("hostManagerServlet.noHost", name));
return;
}
// Prevent starting our own host
if (engine.findChild(name) == host) {
writer.println
(sm.getString("hostManagerServlet.cannotStopOwnHost", name));
return;
}
// Start host
try {
((Lifecycle) engine.findChild(name)).stop();
writer.println
(sm.getString("hostManagerServlet.stopped", name));
} catch (Throwable t) {
getServletContext().log
(sm.getString("hostManagerServlet.stopFailed", name), t);
writer.println
(sm.getString("hostManagerServlet.stopFailed", name));
writer.println(sm.getString("hostManagerServlet.exception",
t.toString()));
return;
}
}
Start the host with the specified name. |